(*******************************************************************************

This file should be used with the VCL fourm post by dpatch on manually zooming.

I know that this is a long "example" application and I am sorry for that.  But
it necessary to help make my point and to allow you to help me.

What I am tryimg to do is programmitically zoom in on the image.
The effect I am looking for is if you were to display the image then
left-click the mouse and drag a box down and to the right.  When the mouse
button is released, the image zooms to the box that was drawn with the mouse.

Thanks in advance,
dave patch
Customer Number: L1530607

dpatch@rockfieldtech.com

*******************************************************************************)
unit Unit1;
interface

uses
  Windows, SysUtils, Classes, Graphics, Controls, Forms, ComCtrls, 
  Dialogs, StdCtrls, TeeProcs, TeEngine, Chart, ExtCtrls, Math,
  Series, TeeSurfa, TeeEdit, TeeTools, TeeComma, VclTee.TeeGDIPlus;

type

  // Record to hold polygons.
  tPolygon = record
    X_Values     : array of single;
    Y_Values     : array of single;
  end;
  tPoloygon_List = array of tPolygon;

  TFloatPoint = record
    X : double;
    Y : double;
  end;

  TForm1 = class(TForm)
    Panel1: TPanel;
    Chart1: TChart;
    Panel2: TPanel;
    ExitBtn: TButton;
    DispImgBtn: TButton;
    ChartEditor1: TChartEditor;
    StatusBar1: TStatusBar;
    Label1: TLabel;
    TeeCommander1: TTeeCommander;
    ApplyZoomBtn: TButton;
    procedure FormCreate(Sender: TObject);
    procedure DispImgBtnClick(Sender: TObject);
    procedure ApplyZoomBtnClick(Sender: TObject);
    procedure ExitBtnClick(Sender: TObject);

  private
    { Private declarations }

    fxScaleOff, fxScaleMul,
    fzScaleOff, fzScaleMul : Double;

    procedure ImgReset;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses Types;

{$R *.dfm}

const
  PaletteMin = -75;
  PaletteIncr = 2;
  PaletteSteps = 20;

  DefaultColorPalette : Array[1..256] of TColor = (
    $000000, $500000, $A00000, $100000, $150000, $1A0000, $200000, $250000, $2A0000,
    $300000, $350000, $3A0000, $400000, $450000, $4A0000, $500000, $550000, $5A0000,
    $600000, $650000, $6A0000, $700000, $750000, $7A0000, $800000, $850000, $8A0000,
    $900000, $950000, $9A0000, $A00000, $A50000, $AA0000, $B00000, $B50000, $BA0000,
    $C00000, $C50000, $CA0000, $D00000, $D50000, $DA0000, $E00000, $E50000, $EA0000,
    $F00000, $F50000, $FA0000, $FF0000, $0F5F00, $0FAF00, $FF1000, $FF1500, $FF1A00,
    $FF2000, $FF2500, $FF2A00, $FF3000, $FF3500, $FF3A00, $FF4000, $FF4500, $FF4A00,
    $FF5000, $FF5500, $FF5A00, $FF6000, $FF6500, $FF6A00, $FF7000, $FF7500, $FF7A00,
    $FF8000, $FF8500, $FF8A00, $FF9000, $FF9500, $FF9A00, $FFA000, $FFA500, $FFAA00,
    $FFB000, $FFB500, $FFBA00, $FFC000, $FFC500, $FFCA00, $FFD000, $FFD500, $FFDA00,
    $FFE000, $FFE500, $FFEA00, $FFF000, $FFF500, $FFFA00, $FFFF00, $FAFF00, $F5FF00,
    $F0FF00, $EAFF00, $E5FF00, $E0FF00, $DAFF00, $D5FF00, $D0FF00, $CAFF00, $C5FF00,
    $C0FF00, $BAFF00, $B5FF00, $B0FF00, $AAFF00, $A5FF00, $A0FF00, $9AFF00, $95FF00,
    $90FF00, $8AFF00, $85FF00, $80FF00, $7AFF00, $75FF00, $70FF00, $6AFF00, $65FF00,
    $60FF00, $5AFF00, $55FF00, $50FF00, $4AFF00, $45FF00, $40FF00, $3AFF00, $35FF00,
    $30FF00, $2AFF00, $25FF00, $20FF00, $1AFF00, $15FF00, $10FF00, $0AFF00, $05FF00,
    $00FF00, $00FF05, $00FF0A, $00FF10, $00FF15, $00FF1A, $00FF20, $00FF25, $00FF2A,
    $00FF30, $00FF35, $00FF3A, $00FF40, $00FF45, $00FF4A, $00FF50, $00FF55, $00FF5A,
    $00FF60, $00FF65, $00FF6A, $00FF70, $00FF75, $00FF7A, $00FF80, $00FF85, $00FF8A,
    $00FF90, $00FF95, $00FF9A, $00FFA0, $00FFA5, $00FFAA, $00FFB0, $00FFB5, $00FFBA,
    $00FFC0, $00FFC5, $00FFCA, $00FFD0, $00FFD5, $00FFDA, $00FFE0, $00FFE5, $00FFEA,
    $00FFF0, $00FFF5, $00FFFF, $00FAFF, $00F5FF, $00F0FF, $00EAFF, $00E5FF, $00E0FF,
    $00DAFF, $00D5FF, $00D0FF, $00CAFF, $00C5FF, $00C0FF, $00BAFF, $00B5FF, $00B0FF,
    $00AAFF, $00A5FF, $00A0FF, $009AFF, $0095FF, $0090FF, $008AFF, $0085FF, $0080FF,
    $007AFF, $0075FF, $0070FF, $006AFF, $0065FF, $0060FF, $005AFF, $0055FF, $0050FF,
    $004AFF, $0045FF, $0040FF, $003AFF, $0035FF, $0030FF, $002AFF, $0025FF, $0020FF,
    $001AFF, $0015FF, $0010FF, $000AFF, $0005FF, $0000FF, $1111FF, $2222FF, $3333FF,
    $4444FF, $5555FF, $6666FF, $7777FF, $8888FF, $9999FF, $AAAAFF, $BBBBFF, $CCCCFF,
    $DDDDFF, $EEEEFF, $FFFFFF, $FFFFFF);


//------------------------------------------------------------------------------
//
// Function DispImgBtnClick
// - This function reads the data, displays the image and draws "my" axis.
//
//
// Important things in this routine:
//
// 1. The first line of the data file reads values necessary to calculate the
//    axis values I need to display.  They are documented below.
//
// 2. As the data is read, it is added to the chart using the method AddXYZ.
//
// 3. I clear the default axis values.  Then I calculate and display "my" axis
//    values using the values read on the first line of the data file.
//
//------------------------------------------------------------------------------
procedure TForm1.DispImgBtnClick(Sender: TObject);
var
  i, j : Integer;
  f    : TextFile;
  Dir  : String;
  ImgData : Array of Array of Double;

begin
  try
    ImgReset;

    // Open data file in the application directory.
    dir := ExtractFileDir(ParamStr(0));
    AssignFile(f, dir+'\DataFile.dat');
    Reset(f);

    //...
    //...The first line of the data file contains four numbers to create my axis
    //...values to properly scale my target image around zero.
    //...
    readln(f, fxScaleMul, fxScaleOff, fzScaleMul, fzScaleOff);

    //...
    //...fxScaleOff - This will be the left most (or smallest) value on the x-axis
    //...fxScaleMul - This is a multiplier that is used to generate labels so
    //...             the right most axis value will be the same as the left most.
    //...             This will put a value of 0 (zero) at the center of the axis.
    //...
    //...fzScaleOff - Same as fxScaleOff but for the y-axis.
    //...fzScaleMul - Same as fxScaleMul but for the y-axis.
    //...


    try
      // Create a dynamic array so everything is similar to my real application.
      SetLength(ImgData, 512, 512);

      try
        (Chart1.Series[0] as TColorGridSeries).IrregularGrid := False;
        //(Chart1.Series[0] as TColorGridSeries).IrregularGrid := True;

        // Read the data file and display the image.
        for i := 0 to 511 do
          begin
            for j := 0 to 511 do
              begin
                // Read in the reat of the data and add it to the chart.
                Read(f, ImgData[i,j]);

                //..............................................................
                //
                // Add the data to the ColorGridSeries using AddXYZ.
                //
                (Chart1.Series[0] as TColorGridSeries).AddXYZ(i+1, ImgData[i,j], j+1);
                //
                // The commented out line below is what I would like to do, but
                // it won't work or is to slow depending how IrregularGrid is set.
                //
                // If you would like, uncomment the line below and comment the
                // line above to see the effect. You can test with IrregularGrid
                // set to both True and False.  When you test, try sliding the
                // image witht he right mouse button.
                //
                // If I could do this I would not have to make mu own axis labels
                // and all my problems go away.  Its just too slow when
                // IrregularGrid is True!
                //
                //(Chart1.Series[0] as TColorGridSeries).AddXYZ(i*xScaleMul+xScaleOff, ImgData[i,j], j*zScaleMul+zScaleOff);
                //
                //..............................................................
               end;

            // Skip to next line of data.
            readln(f);
          end;

        Chart1[0].VertAxis:=aBothVertAxis;
        Chart1[0].HorizAxis:=aBothHorizAxis;

        Chart1.Axes.Top.SetMinMax(Chart1[0].MinXValue * fxScaleMul + fxScaleOff,
                                  Chart1[0].MaxXValue * fxScaleMul + fxScaleOff );

        Chart1.Axes.Right.SetMinMax(Chart1[0].MinYValue * fzScaleMul + fzScaleOff,
                                  Chart1[0].MaxYValue * fzScaleMul + fzScaleOff );

        Chart1.Axes.Top.Increment:=0.5;

        Chart1.Axes.Top.OtherSide:=false;
        Chart1.Axes.Right.OtherSide:=false;
        Chart1.Axes.Left.Visible:=false;
        Chart1.Axes.Bottom.Visible:=false;

      finally
        // Free dynamic array.
        for i := 0 to 511 do
          SetLength(ImgData[i], 0);
        SetLength(ImgData, 0);
      end;

    finally
      CloseFile(f);
    end;

   Chart1.Refresh;

  // Report any errors.
  except on e: Exception do
    MessageDlg('ERROR:'+#13#13+e.Message, mtError, [mbOK], 0);
  end;

end;


//
// Initialize the form.
//
procedure TForm1.ExitBtnClick(Sender: TObject);
begin
  close;
end;



// *****************************************************************************
//
//   Note here that I am using the Top and Right axes to display floating point
//   valuse to speed up the zoom and pan based on your recommendations.
//
// *****************************************************************************
procedure TForm1.FormCreate(Sender: TObject);
begin
  inherited;
  Chart1.View3D := False;
  Chart1.Series[0].Free;
  Chart1.AddSeries(TColorGridSeries);

  //....................................................
  //...Steema fix for image axis labels
  //...
  Chart1[0].VertAxis := aBothVertAxis;
  Chart1[0].HorizAxis := aBothHorizAxis;
  Chart1.Axes.Top.OtherSide := False;
  Chart1.Axes.Right.OtherSide := False;
  //....................................................

  Chart1.Axes.Top.Increment := 1.0;
  Chart1.Axes.Right.Increment := 0.5;

//  Chart1.Axes.Top.Grid.Visible := False;
//  Chart1.Axes.Right.Grid.Visible := False;

   Label1.Caption := 'First hit Display Image to display the image. Then when you press Apply Zoom, '+
                     'I am trying to zoom to +/-3 on both axes.  Note if I don''t hit the Apply zoom '+
                     'button and I zoom using the mouse I get the desired effect.'+#13#13+
                     'Please see the notes in ApplyZoomBtnClick';
end;

//
// Set up the chart
//
procedure TForm1.ImgReset;
var
  k, l, m : Integer;

begin
  // When clear is called, palette information is lost.  Is there a way to
  // clear the data without loosing the palette setup?
  //
  //Chart1.Series[0].Clear;
  //
  if (Chart1.Series[0] as TColorGridSeries).XValues.Count > 0 then
    begin
      (Chart1.Series[0] as TColorGridSeries).XValues.Delete(0, (Chart1.Series[0] as TColorGridSeries).XValues.Count);
      (Chart1.Series[0] as TColorGridSeries).YValues.Delete(0, (Chart1.Series[0] as TColorGridSeries).YValues.Count);
      (Chart1.Series[0] as TColorGridSeries).ZValues.Delete(0, (Chart1.Series[0] as TColorGridSeries).ZValues.Count);
    end;

  Chart1.AxisVisible := True;
  Chart1.Axes.FastCalc := True;
  Chart1.Series[0].Pen.Visible := False;
  Chart1.Series[0].HasZValues := True;

  Chart1.Axes.left.Grid.Visible := False;
  Chart1.Axes.bottom.Grid.Visible := False;

  //...
  //... Axis Labels
  //...
  Chart1.Axes.Bottom.Title.Font.Color := clBlack;
  Chart1.Axes.Bottom.Title.Caption := 'X Axis Caption';
  Chart1.BottomAxis.AxisValuesFormat := '###0.##';

  Chart1.LeftAxis.Title.Font.Color := clBlack;
  Chart1.LeftAxis.Title.Caption := 'Y Axis Caption';
  Chart1.LeftAxis.AxisValuesFormat := '###0.##';
  Chart1.LeftAxis.LabelsOnAxis := True;
  Chart1.LeftAxis.LabelsAlternate := False;

  (Chart1.Series[0] as TColorGridSeries).LegendEvery := 1;
  (Chart1.Series[0] as TColorGridSeries).SmoothBitmap := False;
  (Chart1.Series[0] as TColorGridSeries).CenteredPoints := False;

  (Chart1.Series[0] as TColorGridSeries).UseColorRange := False;
  (Chart1.Series[0] as TColorGridSeries).UsePalette := True;
  (Chart1.Series[0] as TColorGridSeries).ClearPalette();

  m := 1;
  l := Max(Length(DefaultColorPalette) div PaletteSteps, 1);
  for k := 0 to PaletteSteps-1 do
    begin
      (Chart1.Series[0] as TColorGridSeries).AddPalette(PaletteMin+(k)*PaletteIncr, DefaultColorPalette[m]);
      Inc(m,l);
      if m > High(DefaultColorPalette) then
        m := High(DefaultColorPalette)
    end;

  Chart1.Repaint;
end;

procedure TForm1.ApplyZoomBtnClick(Sender: TObject);
var
  rect : trect;

begin

  // What I am tryimg to do is programmitically zoom in on the image.
  // The effect I am looking for is if you were to display the image then
  // left-click the mouse and drag a box down and to the right.  When the mouse
  // button is released, the image zooms to the box that was drawn with the mouse.

  //...Here are 3 different things I have tried, all with different results
  //...Try uncommenting them and see what I mean.



  //... 1

  //...Here I try to zoom with SetMinMax.  When I do this, the data in the window
  //...does not resize

//  Chart1.Axes.Top.SetMinMax(-3, 3);
//  Chart1.Axes.Right.SetMinMax(-3, 3);


  //... 2

  //...I would think that this is the right way to zoom a rectangle on the screen,
  //...but it some not seem to work at all.

//  rect.Create(Chart1.Axes.Top.CalcXPosValue(-3), Chart1.Axes.Right.CalcXPosValue(-3),
//              Chart1.Axes.Top.CalcXPosValue(-3), Chart1.Axes.Right.CalcXPosValue(-3));
//  Chart1.ZoomRect(rect);


  //... 3

  //...I also tried this. It does zoom, but the results are very strange.
  //...I have to pan down and right with he mouce multiple times before seeing the image.
  //...It is as if the image is zoomed incredible far in.  But the data is there

   Rect.Create(Chart1.Series[0].CalcXPosValue(-3.0), Chart1.Series[0].CalcYPosValue(3.0),
               Chart1.Series[0].CalcXPosValue(3.0), Chart1.Series[0].CalcYPosValue(-3.0));
   Chart1.ZoomRect( Rect );


end;

end.

